/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomHTMLCollection_H__
#define __GdomHTMLCollection_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "gdom/GdomNodeList.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomHTMLCollection GdomHTMLCollection;
typedef struct _GdomHTMLCollectionClass GdomHTMLCollectionClass;


#define GDOM_TYPE_HTML_COLLECTION            (gdom_html_collection_get_type())
#define GDOM_HTML_COLLECTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_HTML_COLLECTION, GdomHTMLCollection))
#define GDOM_HTML_COLLECTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_HTML_COLLECTION, GdomHTMLCollection)Class)
#define GDOM_IS_HTML_COLLECTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_HTML_COLLECTION))
#define GDOM_IS_HTML_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_HTML_COLLECTION))
#define GDOM_HTML_COLLECTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_HTML_COLLECTION, GdomHTMLCollectionClass))

typedef struct _GdomHTMLCollectionPrivate GdomHTMLCollectionPrivate;

struct _GdomHTMLCollection {
    GdomDOMObject parent_instance;
    GdomHTMLCollectionPrivate *priv;
};

struct _GdomHTMLCollectionClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_html_collection_get_type (void);

WEBKIT_API GdomNode *
gdom_html_collection_item (GdomHTMLCollection *thiz, gulong index);

WEBKIT_API GdomNode *
gdom_html_collection_named_item (GdomHTMLCollection *thiz, gchar * name);

WEBKIT_API GdomNodeList *
gdom_html_collection_tags (GdomHTMLCollection *thiz, gchar * name);

G_END_DECLS

#endif /* __GdomHTMLCollection_H__ */
